#!/bin/bash
# coreboot.check v0.01
# This script is intended to check the hardware specs of a laptop.
# This script is a work started by Nomadicus and released under GPL.
# It is built off the work from http://www.coreboot.org/Laptop#HOWTO_to_find_a_way .
# To learn about coreboot go to: http://www.coreboot.org/Welcome_to_coreboot .

#_lspci
#_lspnp
#_lsusb
#_superiotool
#_inteltool
#_ectool
#_msrtool
#_dmidecode
#_biosdecode
#_nvramtool
#_dmesg
#_flashrom_info
#_flashrom_read


#### Functions ####

function download_tools
{
	mkdir coreboot
	cd coreboot
	svn co svn://coreboot.org/coreboot/trunk/util/superiotool
	svn co svn://coreboot.org/coreboot/trunk/util/inteltool
	svn co svn://coreboot.org/coreboot/trunk/util/ectool
	cvs -z3 -d:pserver:anonymous@cvs.savannah.nongnu.org:/sources/dmidecode co dmidecode
	svn co svn://coreboot.org/coreboot/trunk/util/msrtool
	svn co svn://coreboot.org/coreboot/trunk/util/nvramtool
	svn co svn://coreboot.org/coreboot/trunk/util/nvramtool
} # end download_tools

function install_tools
{
	cd dmidecode  
	make; sudo make install
	cd ..
	cd ectool  
	make; sudo make install
	cd ..
	cd inteltool  
	make; sudo make install
	cd ..
	cd msrtool  
	./configure; make; sudo make install; sudo modprobe msr
	cd ..
	cd nvramtool  
	make; sudo make install
	cd ..
	cd superiotool  
	make; sudo make install
	cd .. 
	cd trunk
	make; sudo make install
	cd ..
} # end install_tools

function make_all_logs
{
	all_case=1
#	make_enter_logs_directory

	# calling all log functions
	make_lspci_log
	make_lspnp_log
	make_lsusb_log
	make_superiotool_log
	make_inteltool_log
	make_msrtool_log
	make_dmidecode_log
	make_biosdecode_log
	make_nvramtool_log
	make_dmesg_log
	make_flashrom_info_log
	make_flashrom_read_log
	make_ectool_log

	exit_logs_directory_verbose
} # end make_all_logs

function make_enter_logs_directory
{
#	echo "	    "
	cd $home_directory
	if [ -d logs ] #&& [ $logsdir=1 ]
		then 
			case $logsdir in
			0 )	if [ $verbose_case = 1 ]
					then
						echo	
						echo "	The logs directory is already present."	
						echo				
						echo "	-------------------------------------------------------"
				fi
 				cd logs
				logsdir=1
				;;
			1 )	cd logs
				;;
			esac
#			if [ logsdir = 0 ] 
#				then			
#					echo
#					echo "The logs directory is already present." 
#					cd logs
#					logsdir=1
#			fi
		else
			if [ $verbose_case = 1 ]
				then
					echo 
#					echo "	-------------------------------------------------------"
					echo "	The logs diretory is not present."
					echo
					echo "	. . . creating the logs directory . . ."			
#					echo 
			fi
			mkdir -p logs
			if [ $verbose_case = 1 ]
				then
					echo 
					echo "	The logs diretory has been created."
					echo
					echo "	-------------------------------------------------------"			
#					echo 
			fi
			cd logs
			logsdir=1

	fi
#	case $logsdir in
#	0 )	echo
#		echo "The logs directory is already present." 
#		echo
#		cd logs
#		logsdir=1
#		;;
#	1 )	cd logs
#		;;
#	esac
#	cd logs
#	echo "	    "
} # end make_enter_logs_directory

function exit_logs_directory
{
	cd ..
	echo

} # end exit_logs_directory

function exit_logs_directory_verbose
{
	echo 	
	echo "	 Here is what was created in the logs directory:   "
	echo
#	cd ..
	ls logs
	echo "	   "
	echo "	-------------------------------------------------------"
	cd ..
} # end exit_logs_directory_verbose

function start_log()
{
	if [ $verbose_case = 1 ]
		then
#			echo "	-------------------------------------------------------"
			echo "	    "
			echo "	. . . starting $1.log . . .   "
			echo 
	fi
#	echo "	    "
} # end start_log ()

function end_log ()
{
	if [ $verbose_case = 1 ]
		then
			echo "	    "
			echo "	. . . $1.log finnished . . .   "
			echo
			echo "	-------------------------------------------------------"
	fi
	cd ..
} # end end_log ()

function all_verbose_case_check
{
	if [ $verbose_case = 1 ]
		then
			exit_logs_directory_verbose					
		else
			exit_logs_directory
#			if [ $all_case = 0 ] && [ $verbose_case = 0 ]
#				then
#					exit_logs_directory					
#				else
#					exit_logs_directory_verbose
#			fi
	fi		

#	if [ $all_case = 0 ]
#		then
#			exit_logs_directory_verbose					
#		else
#			if [ $verbose_case = 1 ]
#				then
#					exit_logs_directory_verbose					
# 				else
#					exit_logs_directory
#			fi
#	fi		
} # end all_verbose_case_check

function make_lspci_log
{	
	make_enter_logs_directory
	
	start_log lspci

	sudo lspci -nnvvvxxxx > lspci.log

	end_log lspci
	
	all_verbose_case_check

} # end 
	
function make_lspnp_log
{
	make_enter_logs_directory
	
	start_log lspnp

	sudo lspnp -vv > lspnp.log

	end_log lspnp

	all_verbose_case_check
} # end 

function make_lsusb_log
{
	make_enter_logs_directory
	
	start_log lsusb

	sudo lsusb -vvv > lsusb.log

	end_log lsusb

	all_verbose_case_check
} # end 
	
function make_superiotool_log
{
	make_enter_logs_directory
	
	start_log superiotool

	sudo superiotool -deV > superiotool.log

	end_log superiotool

	all_verbose_case_check
} # end 
	
function make_inteltool_log
{
	make_enter_logs_directory
	
	start_log inteltool

	sudo inteltool -a > inteltool.log

	end_log inteltool

	all_verbose_case_check
} # end 
	
function make_msrtool_log
{
	make_enter_logs_directory
	
	start_log msrtool

	sudo msrtool -v > msrtool.log

	end_log msrtool

	all_verbose_case_check
} # end 
	
function make_dmidecode_log
{
	make_enter_logs_directory
	
	start_log dmidecode

	sudo dmidecode > dmidecode.log	

	end_log dmidecode

	all_verbose_case_check
} # end 
	
function make_biosdecode_log
{
	make_enter_logs_directory
	
	start_log biosdecode

	sudo biosdecode > biosdecode.log

	end_log biosdecode

	all_verbose_case_check
} # end 
	
function make_nvramtool_log
{
	make_enter_logs_directory
	
	start_log nvramtool

	sudo nvramtool -x > nvramtool.log	

	end_log nvramtool

	all_verbose_case_check
} # end 
	
function make_dmesg_log
{
	make_enter_logs_directory
	
	start_log dmesg

	sudo dmesg > dmesg.log	

	end_log dmesg

	all_verbose_case_check
} # end 
	
function make_flashrom_info_log
{
	make_enter_logs_directory
	
	start_log flashrom_info

	sudo flashrom -V -p internal:laptop=force_I_want_a_brick > flashrom_info.log	

	end_log flashrom_info

	all_verbose_case_check
} # end 
	
function make_flashrom_read_log
{
	make_enter_logs_directory
	
	start_log flashrom_read

	sudo flashrom -V -p internal:laptop=force_I_want_a_brick -r rom.bin > flashrom_read.log	

	end_log flashrom_read

	all_verbose_case_check
} # end 
	
function make_ectool_log
{
	make_enter_logs_directory
	
	start_log ectool

	echo "	*** this log takes longer to build than the others ***  "
	sudo ectool -V > ectool.log

	end_log ectool

	all_verbose_case_check
} # end 
	


#make_lspci_log
#make_lspnp_log
#make_lsusb_log
#make_superiotool_log
#make_inteltool_log
#make_ectool_log
#make_msrtool_log
#make_dmidecode_log
#make_biosdecode_log
#make_nvramtool_log
#make_dmesg_log
#make_flashrom_info_log
#make_flashrom_read_log

function usage
{
	echo
	current_date
	echo
	echo "coreboot.check '$version' is used to download, install utilities, and create logs to check for hardware support."
	echo "**** this is still a work in progress -- not all features work ****"
	echo
	echo "Log creation syntax:" $(basename $0) [option] [log]
	echo ""
	echo "Log creation syntax:" $(basename $0) [option] [directory]
	echo "**** directory input is not yet supported, defaults are coreboot and coreboot/logs ****"
	echo ""
	echo "These are the avaliable options:"
	echo ""
	echo "  -d  || --download		directory	directory to download tools to"
	echo "  -i  || --install		directory	install tools *must be in parent directory used for downloading sources 	"
	echo ""
	echo "  -h  || --help					this page"
	echo "  -a  || --about					about coreboot.check"
	echo "  -c  || --changes				display change log"
	echo "  -v  || --verbose				verbose"
	echo ""
	echo "These are the avaliable logs to create:"
	echo ""
	echo "	-all  			create all log files"	
	echo ""
	echo "	-lspci			create lspci.log file"
	echo "	-lspnp			create lspnp.log file"
	echo "	-lsusb			create lsusb.log file"
	echo "	-superiotool		create superiotool.log file"
	echo "	-inteltool		create inteltool.log file"
	echo "	-msrtool		create msrtool.log file"
	echo "	-dmidecode		create dmidecode.log file"
	echo "	-biosdecode		create biosdecode.log file"
	echo "	-nvramtool		create nvramtool.log file"
	echo "	-dmesg			create dmesg.log file"
	echo "	-flashrom_info		create flashrom_info.log file"
	echo "	-flashrom_read		create flashrom_read.log file"
	echo "	-ectool			create ectool.log file"
	echo
} # end usage

function about
{
	echo
	echo ". . . About . . ."
	echo
	echo "	coreboot.check '$version'"
	echo
	echo "	  "
	echo "	This script is intended to check the hardware specs of a laptop."
	echo "	"
	echo "	This script is a work started by Nomadicus and released under GPL."
	echo "	It is built off the work from: ( http://www.coreboot.org/Laptop#HOWTO_to_find_a_way )."
	echo
	echo "	To learn about coreboot go to: ( http://www.coreboot.org/Welcome_to_coreboot )."
	echo ""
	echo "	Send questions, comments or suggestions to: ( developer@nomadicus.net )."
	echo ""
} # end about

function change_log
{
	echo
	echo ". . . Change Log . . ."
	echo 
	echo "	> coreboot.check v0.01 - 09.14.2010 "
	echo
	echo "	  -install   "
	echo "	  -download " 
	echo "	  -all "
	echo "	    "
	echo "      "
	echo "	> coreboot.check v0.02 - 09.15.2010  "
	echo ""
	echo "	  -lspci			create lspci.log file"
	echo "	  -lspnp			create lspnp.log file"
	echo "	  -lsusb			create lsusb.log file"
	echo "	  -superiotool		create superiotool.log file"
	echo "	  -inteltool		create inteltool.log file"
	echo "	  -msrtool		create msrtool.log file"
	echo "	  -dmidecode		create dmidecode.log file"
	echo "	  -biosdecode		create biosdecode.log file"
	echo "	  -nvramtool		create nvramtool.log file"
	echo "	  -dmesg			create dmesg.log file"
	echo "	  -flashrom_info		create flashrom_info.log file"
	echo "	  -flashrom_read		create flashrom_read.log file"
	echo "	  -ectool			create ectool.log file"
	echo "      "
	echo "	    "
	echo "	  - future plans for coreboot.check as of v0.02   "
	echo "	    "
#	echo "	    "
	echo "    - Option to input alternate directory."
	echo ""	
	echo "	  - Hopefully someone will find it valuable, use it, and possibly integrate it into a coreboot wiki, tutorial, or how to. "
	echo ""
	echo "	  - I also would like to configure coreboot.check to fully automate download, install, create log files, arkive the log files and post them to the coreboot mail list for analysis.  Before I can totally achieve this I need to make sure I can efficiently find all the dependencies and check the system to discover what dependencies the os has already satasfied."
	echo ""
	echo "	  - If there is anyone more experienced who is willing to contribute please do so."
	echo "	    " 
	echo "      "
	echo 
} # end change_log

function current_date 
{
	echo	
	echo "Today's date is:"
	date +"%A, %B %-d, %Y"
#	echo
}


#### MAIN ####

# Set defaults

	home_directory=$PWD
	filename=	
	outdir=
	outfile=
	createdir=
	logsdir=0
	all_case=0
	verbose_case=0
	version=v0.02

# Check for arguments and process

if [ "$1" != "" ]; then 
	while [ "$1" != "" ]; do
		case $1 in
			-d | --download )	shift
						download_tools
						;;
			-i | --install)		shift
						install_tools
						;;
			-all | --all )		shift
						make_all_logs
#						exit_logs_directory_verbose
						;;
			-v | -verbose )		#shift
						verbose_case=1
						;;
			-lspci )		shift
						make_lspci_log
#						exit_logs_directory_verbose
						;;
			-lspnp )		shift
						make_lspnp_log
#						exit_logs_directory_verbose
						;;
			-lsusb )		shift
						make_lsusb_log
#						exit_logs_directory_verbose
						;;
			-superiotool )		shift
						make_superiotool_log
#						exit_logs_directory_verbose
						;;
			-inteltool )		shift
						make_inteltool_log
#						exit_logs_directory_verbose
						;;
			-ectool )		shift
						make_ectool_log
#						exit_logs_directory_verbose
						;;
			-msrtool )		shift
						make_msrtool_log
#						exit_logs_directory_verbose
						;;
			-dmidecode )		shift
						make_dmidecode_log
						;;
			-biosdecode )		shift
						make_biosdecode_log
						;;
			-nvramtool )	 	shift
						make_nvramtool_log
						;;
			-dmesg )		shift
						make_dmesg_log
						;;
			-flashrom_info )	shift
						make_flashrom_info_log
						;;
			-flashrom_read )	shift
						make_flashrom_read_log
						;;
			-h | --help )		usage
						exit
						;;
			-a | --about)		about
						exit
						;;
			-c | --changes)		change_log
						exit
						;;
			* )			usage
						exit 1	
   		esac
	shift
	done
else
    usage
fi

exit 0
